clear,clc, close all;
x1 = 2e-3;
y1 = 0;
x2 = -2e-3;
y2 = 0;
x3 = 0;
y3 = 3e-3;

q0 = 1e10*1.6022e-19;
q1 = +q0;
q2 = -q0;
q3 = +2*q0;
eps0 = 8.854e-12;
% t = 0:pi/50:pi;
t = (-5:1/3:5).*1e-3;
[x,y] = meshgrid(t);
% z = sin(x) + cos(y)*sin(x);

z = q1./(eps0*4*pi*sqrt((x-x1).^2+(y-y1).^2)) + ... % pole 1. naboje
    q2./(eps0*4*pi*sqrt((x-x2).^2+(y-y2).^2)) + ... % pole 2. naboje
    q3./(eps0*4*pi*sqrt((x-x3).^2+(y-y3).^2));      % pole 3. naboje

[gx gy] = gradient(z);
div = divergence(x,y,gx,gy);

gx(gx == Inf) = NaN;
gy(gy == Inf) = NaN;
gx(gx == -Inf) = NaN;
gy(gy == -Inf) = NaN;

figure('pos',[50 50 1300 700]);
subplot(1,2,1);
mesh(x,y,z);
subplot(1,2,2);
contour(x,y,z);
hold on;
quiver(t,t,gx,gy);

figure('pos',[250 250 700 700]);
pcolor(div);